#!/usr/bin/env python
"""
_BlockInfoByDatasetPath_

Monitoring DAO classes for Blocks in Tier0
"""
__all__ = []
__revision__ = "$Id: BlockInfoByDatasetPath.py,v 1.1 2010/03/17 15:22:51 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class BlockInfoByDatasetPath(DBFormatter):
    
    sql = """SELECT name AS block_name, export_start_time As injection_time FROM block
              WHERE name LIKE :datasetpath"""
                           
    def execute(self, datasetpath, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given datasetpath and then format and return
        the result.
        """
        bindVars = {"datasetpath": datasetpath + "#%"}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)