#!/usr/bin/env python
"""
_EventsPerLumisection_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: EventsPerLumisection.py,v 1.1 2010/03/17 15:22:47 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class EventsPerLumisection(DBFormatter):
    
    sql = """SELECT lumi_id, SUM(events) AS events FROM streamer
               WHERE run_id = :run
               GROUP BY lumi_id 
               ORDER BY lumi_id"""
                            
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)