#!/usr/bin/env python
"""
_RepackEvents_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: RepackEvents.py,v 1.1 2010/03/17 15:22:46 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class RepackEvents(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """SELECT DISTINCT events FROM wmbs_file_details
                INNER JOIN wmbs_file_dataset_path_assoc ON wmbs_file_dataset_path_assoc.file_id = wmbs_file_details.id
                INNER JOIN dataset_path ON wmbs_file_dataset_path_assoc.dataset_path_id = dataset_path.id 
                INNER JOIN data_tier ON dataset_path.data_tier = data_tier.id 
                INNER JOIN wmbs_file_runlumi_map ON wmbs_file_details.id = wmbs_file_runlumi_map.fileid 
                INNER JOIN wmbs_fileset_files ON wmbs_fileset_files.fileid = wmbs_file_details.id 
                INNER JOIN wmbs_fileset ON wmbs_fileset_files.fileset = wmbs_fileset.id 
            WHERE run = :run AND data_tier.name = 'RAW' AND wmbs_fileset.name = 'DBSUploadable'
          """
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)