#!/usr/bin/env python
"""
_InCompleteRuns_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: ProcessingFileStatus.py,v 1.1 2010/03/17 15:22:45 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class ProcessingFileStatus(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """SELECT COUNT(DISTINCT acquired_t.fileid) AS Acquired,
              COUNT(DISTINCT complete_t.fileid) AS Completed,
              COUNT(DISTINCT failed_t.fileid) AS Failed 
            FROM wmbs_file_runlumi_map 
            LEFT OUTER JOIN (SELECT * FROM wmbs_sub_files_acquired WHERE subscription = 
                        (SELECT id FROM wmbs_subscription WHERE workflow = 
                        (SELECT id FROM wmbs_workflow WHERE spec = :workflow))) acquired_t 
                 ON wmbs_file_runlumi_map.fileid = acquired_t.fileid 
            LEFT OUTER JOIN 
            (SELECT * FROM wmbs_sub_files_complete WHERE subscription = 
               (SELECT id FROM wmbs_subscription WHERE workflow = 
                  (SELECT id FROM wmbs_workflow WHERE spec = :workflow))) complete_t 
              ON wmbs_file_runlumi_map.fileid = complete_t.fileid
            LEFT OUTER JOIN 
            (SELECT * FROM wmbs_sub_files_failed WHERE subscription = 
               (SELECT id FROM wmbs_subscription WHERE workflow =  
                  (SELECT id FROM wmbs_workflow WHERE spec = :workflow))) failed_t 
              ON wmbs_file_runlumi_map.fileid = failed_t.fileid 
            WHERE run = :run"""
                 
    def execute(self, run, workflow, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        binds = {'run': run, 'workflow': workflow}
        result = self.dbi.processData(self.sql,binds, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)