#!/usr/bin/env python
"""
_RepackFileSizeAlarm_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: RepackFileSizeAlarm.py,v 1.1 2010/03/17 15:22:45 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class RepackFileSizeAlarm(DBFormatter):
    
    #TO: check what else is needed for return item
    REPACK_FILE_SIZE_LIMIT = 1000000
    sql = """SELECT distinct filesize, wmbs_file_details.id AS repacked_id FROM wmbs_file_details 
               INNER JOIN wmbs_file_dataset_path_assoc ON wmbs_file_details.id = wmbs_file_dataset_path_assoc.file_id 
               INNER JOIN dataset_path ON wmbs_file_dataset_path_assoc.dataset_path_id = dataset_path.id 
               INNER JOIN data_tier ON dataset_path.data_tier = data_tier.id 
               INNER JOIN wmbs_file_runlumi_map ON wmbs_file_details.id = wmbs_file_runlumi_map.fileid 
              WHERE data_tier.name = 'RAW' AND run = :run 
             AND filesize >  %s ORDER BY filesize""" % REPACK_FILE_SIZE_LIMIT
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)