#!/usr/bin/env python
"""
_RepackFileSizePerDataset_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: RepackFileSizePerDataset.py,v 1.1 2010/03/17 15:22:45 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class RepackFileSizePerDataset(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """SELECT SUM(filesize) AS total_filesize, primary_dataset.name AS name FROM wmbs_file_details  
              INNER JOIN wmbs_file_dataset_path_assoc ON wmbs_file_details.id = wmbs_file_dataset_path_assoc.file_id 
              INNER JOIN dataset_path ON wmbs_file_dataset_path_assoc.dataset_path_id = dataset_path.id  
              INNER JOIN primary_dataset ON dataset_path.primary_dataset = primary_dataset.id 
              INNER JOIN data_tier ON dataset_path.data_tier = data_tier.id 
              INNER JOIN wmbs_file_runlumi_map ON wmbs_file_details.id = wmbs_file_runlumi_map.fileid 
              INNER JOIN wmbs_fileset_files ON wmbs_file_details.id = wmbs_fileset_files.fileid 
             WHERE run = :run AND data_tier.name = 'RAW' AND wmbs_fileset_files.fileset = 
                (SELECT id FROM wmbs_fileset WHERE name = 'DBSUploadable') 
             GROUP BY primary_dataset.name """
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)