#!/usr/bin/env python
"""
_Information on  temp alca files by run__

T0Mon: this class is used in the run page [temp alca file table]
"""

from T0.DAS.Database.Oracle.Files.RepackFilesByRun import * 

class TempAlcaFilesByRun(RepackFilesByRun):
   sqlDataTier="'ALCARECO'"
   sqlFileSet="'Mergeable'" 
   sql=""" SELECT DISTINCT f.id, f.filesize, f.events, pd.name as dataset, f.lfn, proc.name as skim 
            FROM  wmbs_file_details f 
           INNER JOIN  wmbs_file_dataset_path_assoc a ON (a.file_id = f.id)
           INNER JOIN  dataset_path dp ON (a.dataset_path_id = dp.id)
           INNER JOIN  primary_dataset pd ON (dp.primary_dataset = pd.id)
           INNER JOIN  data_tier dt ON (dp.data_tier = dt.id)  
           INNER JOIN  wmbs_file_runlumi_map m ON (f.id = m.fileid)
           INNER JOIN  wmbs_fileset_files fsf ON (f.id = fsf.fileid)
           INNER JOIN  wmbs_fileset fs ON (fs.id = fsf.fileset)
           INNER JOIN  processed_dataset proc ON (dp.processed_dataset = proc.id) WHERE 
             dt.name = %s   and m.run = %s and fs.name =%s  
            ORDER BY  1 DESC""" 

class TempAlcaFilesByRun_count(RepackFilesByRun_count):
   sqlDataTier="'ALCARECO'"
   sqlFileSet="'Mergeable'" 
   sql=""" SELECT COUNT(DISTINCT f.id) 
            FROM  wmbs_file_details f 
           INNER JOIN  wmbs_file_dataset_path_assoc a ON (a.file_id = f.id)
           INNER JOIN  dataset_path dp ON (a.dataset_path_id = dp.id)
           INNER JOIN  primary_dataset pd ON (dp.primary_dataset = pd.id)
           INNER JOIN  data_tier dt ON (dp.data_tier = dt.id)  
           INNER JOIN  wmbs_file_runlumi_map m ON (f.id = m.fileid)
           INNER JOIN  wmbs_fileset_files fsf ON (f.id = fsf.fileid)
           INNER JOIN  wmbs_fileset fs ON (fs.id = fsf.fileset)
           INNER JOIN  processed_dataset proc ON (dp.processed_dataset = proc.id) 
           WHERE 
             dt.name = %s   and m.run = %s and fs.name =%s  
            ORDER BY  1 DESC""" 