#!/usr/bin/env python
"""
_Information on repack files by id _


"""


from WMCore.Database.DBFormatter import DBFormatter

class TempRepackFilesById(DBFormatter): 


   sqlDataTier="'RAW'"
   sqlFileSet="'Mergeable'"
   sql="""SELECT DISTINCT
  f.id,
  f.filesize,
  f.events,
  pd.name,
  f.lfn
FROM
  wmbs_file_details f
INNER JOIN wmbs_file_dataset_path_assoc a ON (a.file_id          = f.id AND f.id   = :id)
INNER JOIN dataset_path dp                ON (a.dataset_path_id  = dp.id)
INNER JOIN primary_dataset pd             ON (dp.primary_dataset = pd.id)
INNER JOIN data_tier dt                   ON (dp.data_tier       = dt.id AND dt.name   = %s)
INNER JOIN wmbs_file_runlumi_map m        ON (f.id               = m.fileid)
INNER JOIN wmbs_fileset_files fsf         ON (f.id               = fsf.fileid)
INNER JOIN wmbs_fileset fs                ON (fs.id              = fsf.fileset  AND fs.name = %s )"""
  
   def buildQuery(self):
      self.sql=self.sql % (self.sqlDataTier, self.sqlFileSet)
      
   def execute(self, rid, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given  statistics and then format and return
        the result.
        """
        bindVars={}
        try:
          if int(rid)>0:
           self.buildQuery()
           bindVars = {"id": rid}
          else:  
            raise Exception('zeroRun')
        except Exception:
            return {"Error" : "wrong id"} 
        #print self.sql
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result) 
