#!/usr/bin/env python
"""
_UnmergeFilesForRun_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: UnmergedFilesForRun.py,v 1.1 2010/03/17 15:22:45 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class UnmergedFilesForRun(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """SELECT DISTINCT wmbs_file_details.id AS Id, 
                wmbs_file_details.filesize AS FileSize, wmbs_file_details.lfn AS Lfn, 
                wmbs_file_details.events AS Events, primary_dataset.name AS PrimaryDataset, 
                processed_dataset.name AS ProcessedDataset, data_tier.name as DataTier 
                FROM wmbs_file_details 
                INNER JOIN wmbs_file_runlumi_map ON wmbs_file_details.ID = wmbs_file_runlumi_map.fileid 
                INNER JOIN wmbs_file_dataset_path_assoc ON wmbs_file_dataset_path_assoc.file_id = wmbs_file_details.ID 
                INNER JOIN dataset_path ON dataset_path.id = wmbs_file_dataset_path_assoc.dataset_path_id 
                INNER JOIN primary_dataset ON primary_dataset.id = dataset_path.primary_dataset 
                INNER JOIN wmbs_fileset_files ON wmbs_fileset_files.fileid = wmbs_file_details.id 
                INNER JOIN data_tier ON data_tier.id = dataset_path.data_tier 
                INNER JOIN processed_dataset on processed_dataset.id = dataset_path.processed_dataset 
                WHERE wmbs_fileset_files.fileset = (SELECT id FROM wmbs_fileset WHERE name = 'Transferable') 
                AND wmbs_file_runlumi_map.run = :run
          """
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)