#!/usr/bin/env python
"""
_GetFailedRepackJob_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: GetFailedRepackJob.py,v 1.2 2010/04/07 12:22:14 hufnagel Exp $"
__version__ = "$Revision: 1.2 $"

from WMCore.Database.DBFormatter import DBFormatter

class GetFailedRepackJob(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """SELECT repack_job_def.job_id,
                    repack_job_def.job_status,
                    repack_job_def.definition_time
             FROM repack_job_def 
             INNER JOIN job_status ON
               job_status.id = repack_job_def.job_status AND
               job_status.status IN ( 'Failure', 'Abandoned' )
             WHERE definition_time > :definition_time
             ORDER BY repack_job_def.job_id"""

    def execute(self, definition_time, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"definition_time": definition_time}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)
