#!/usr/bin/env python
"""
_RepackJobStatus_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: RepackJobStatus.py,v 1.1 2010/03/17 15:22:45 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class RepackJobStatus(DBFormatter):
    
    sql = """ SELECT COUNT(st.status), st.status FROM repack_job_def J 
               INNER JOIN job_status st ON J.job_status = st.id
              GROUP BY st.status"""
             
    def execute(self, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)