#!/usr/bin/env python
"""
_IsRunComplete_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: IsRunComplete.py,v 1.1 2010/03/17 15:22:44 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class IsRunComplete(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """ SELECT run_status.id, run_status.status FROM run  
               INNER JOIN run_status ON run.run_status = run_status.id  
              WHERE run_status.status = 'Complete' AND run.run_id = :run"""
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)