#!/usr/bin/env python
"""
_IsRunExpressComplete_

Checks if a run has finished 
"""
__all__ = []
__revision__ = "$Id: IsRunExpressComplete.py,v 1.1 2010/05/18 16:35:02 hufnagel Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

from T0.GenericTier0 import Tier0DB
from T0.State.Database.Reader.ListRuns import listExpressProcCompleteForRun


class IsRunExpressComplete(DBFormatter):
    
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Just call the already existing Tier0 method
        """
        dbConn = Tier0DB(connectionParams = {}, manageGlobal = True, initConnection = False)
        return listExpressProcCompleteForRun(dbConn, run)
