#!/usr/bin/env python
"""
_RunDetail_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: RunDetail.py,v 1.2 2010/06/25 11:43:38 hufnagel Exp $"
__version__ = "$Revision: 1.2 $"

from WMCore.Database.DBFormatter import DBFormatter

class RunDetail(DBFormatter):
    
    #TODO not use *
##     sql = """SELECT * FROM (SELECT DISTINCT primary_dataset.name AS Dataset,
##                 reco_config.do_reco AS RecoEnabled, reco_config.proc_version AS RecoProcVersion,
##                 cmssw_version.name AS RecoCmsswVersion, reco_config.global_tag AS RecoGlobalTag,
##                 reco_config.config_url AS RecoConfigUrl FROM reco_config 
##                 INNER JOIN primary_dataset ON reco_config.primary_dataset_id = primary_dataset.id
##                 INNER JOIN cmssw_version ON reco_config.cmssw_version_id = cmssw_version.id
##                 WHERE reco_config.run_id = :run) myreco 
##                 INNER JOIN
##                    (SELECT DISTINCT primary_dataset.name AS Dataset, alca_config.do_alca AS AlcaEnabled, 
##                 alca_config.proc_version AS AlcaProcVersion, cmssw_version.name AS AlcaCmsswVersion, 
##                 alca_config.config_url AS AlcaConfigUrl FROM alca_config 
##                 INNER JOIN primary_dataset ON alca_config.primary_dataset_id = primary_dataset.id
##                 INNER JOIN cmssw_version ON alca_config.cmssw_version_id = cmssw_version.id 
##                 WHERE alca_config.run_id = :run) myalca  ON myreco.Dataset = myalca.Dataset INNER JOIN 
##                 (SELECT DISTINCT primary_dataset.name AS Dataset,  
##                 repack_config.proc_version AS RepackProcVersion 
##                 FROM repack_config 
##                 INNER JOIN primary_dataset  ON repack_config.primary_dataset_id = primary_dataset.id
##                 WHERE repack_config.run_id = :run) myrepack  ON myrepack.Dataset = myreco.Dataset
##                 LEFT OUTER JOIN (SELECT  primary_dataset.name AS Dataset, 
##                 t1skim_config.CONFIG_URL AS T1skimConfigUrl, cmssw_version.name AS T1SkimCmssswVersion, 
##                 t1skim_config.proc_version AS T1SkimProcVersion, t1skim_config.skim_name AS T1SkimName,
##                 data_tier.name As DataTierName FROM primary_dataset
##                 INNER JOIN t1skim_config ON t1skim_config.primary_dataset_id = primary_dataset.id
##                 INNER JOIN cmssw_version ON t1skim_config.cmssw_version_id = cmssw_version.id 
##                 INNER JOIN data_tier ON data_tier.id = t1skim_config.data_tier_id 
##                 WHERE  t1skim_config.run_id = :run) myt1skim ON myt1skim.Dataset = myrepack.Dataset
##           """
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)
