#!/usr/bin/env python
"""
_RunTable_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: RunTable.py,v 1.1 2010/03/17 15:22:44 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class RunTable(DBFormatter):
    
    #TODO: don't use *
    sql = """SELECT * FROM 
                (SELECT r.RUN_ID, r.START_TIME, r.END_TIME , r.PROCESS ,  r.HLTKEY,
                r.ACQ_ERA, st.STATUS , count(distinct str.streamer_id) AS STREAMERS 
                    FROM RUN r, RUN_STATUS st, streamer str where str.run_id = r.run_id AND r.RUN_STATUS = st.ID
              GROUP BY r.RUN_ID, r.START_TIME, r.END_TIME, r.PROCESS, r.HLTKEY, r.ACQ_ERA, st.STATUS
              ORDER BY r.RUN_ID DESC) WHERE RowNum <= 30"""
             
    def execute(self, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)