#!/usr/bin/env python
"""
_RunsByStates_

Monitoring DAO classes for Runs in Tier0
"""
__all__ = []
__revision__ = "$Id: RunsByStates.py,v 1.1 2010/03/17 15:22:44 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class RunsByStates(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """SELECT run.RUN_ID, run_status.STATUS, run.START_TIME 
               FROM run 
               INNER JOIN run_status ON run.RUN_STATUS = run_status.ID 
            WHERE run.RUN_STATUS = (SELECT ID FROM run_status WHERE
                             STATUS = :status)"""
    
    def execute(self, run_status, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given status list and then format and return
        the result.
        """
        if type(run_status) != list:
            run_status = [run_status]
                
        bindVars = []
        for status in run_status:
            bindVars.append({"status": status})
        
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)