#!/usr/bin/env python
"""
_number of complete files of the express process _

T0Mon: % in the front page
"""
from T0.DAS.Database.Oracle.Stats.GeneralNumStat import GeneralNumStat

class NumExpressCompleted(GeneralNumStat):
    
    fileset="'ExpressMergeable'"
    sql="""WITH subscription_id AS (  SELECT id
                 FROM wmbs_subscription
                 WHERE fileset= ( 
                     SELECT id
                     FROM  wmbs_fileset
                    WHERE name=%s ))
SELECT m.run as run_id,
 COUNT(DISTINCT fc.fileid) AS completed_count,
 COUNT(DISTINCT ff.fileid) AS failed_count
   FROM wmbs_file_details f
   INNER JOIN wmbs_file_runlumi_map m ON (f.id = m.fileid)
   INNER JOIN wmbs_job_assoc ja       ON (ja.fileid = m.fileid)
   LEFT OUTER JOIN wmbs_sub_files_complete fc ON (fc.fileid =f.id AND fc.subscription IN (select * from subscription_id))
   LEFT OUTER JOIN wmbs_sub_files_failed ff ON (ff.fileid =f.id AND ff.subscription IN (select * from subscription_id))
   WHERE
          m.run>= :lowRunId
         AND m.run<=:highRunId
    GROUP BY m.run
    ORDER BY m.run """
    
    def buildQuery(self):
      self.sql=self.sql %(self.fileset)
      
      