
#!/usr/bin/env python
"""
_number of complete files of the repack process _

T0Mon: % in the front page
"""

from T0.DAS.Database.Oracle.Stats.GeneralNumStat import GeneralNumStat

class NumRepackCompleted(GeneralNumStat):
    datatier="'RAW'"
    sql="""WITH subscription_id AS (  SELECT id
                 FROM wmbs_subscription
                 WHERE fileset= ( 
                     SELECT id
                     FROM  wmbs_fileset
                    WHERE name='Mergeable' ))
SELECT
  m.run as run_id,
 COUNT(DISTINCT cf.fileid) AS completed_count,
 COUNT(DISTINCT ff.fileid) AS failed_count
FROM
  wmbs_file_details f
INNER JOIN wmbs_file_dataset_path_assoc a ON (a.file_id         = f.id)
INNER JOIN dataset_path dp                ON (a.dataset_path_id = dp.id)
INNER JOIN wmbs_file_runlumi_map m        ON (f.id              = m.fileid)
LEFT OUTER JOIN wmbs_sub_files_complete cf ON (cf.fileid =f.id AND cf.subscription IN (select * from subscription_id))
LEFT OUTER JOIN wmbs_sub_files_failed ff ON (ff.fileid =f.id AND ff.subscription IN (select * from subscription_id))
WHERE
  dp.data_tier =  (SELECT id FROM data_tier WHERE name = %s)
   AND m.run>= :lowRunId
  AND m.run<= :highRunId
  GROUP BY m.run
  ORDER BY m.run  """
   
    
    def buildQuery(self):
      self.sql=self.sql %(self.datatier)
      
      