#!/usr/bin/env python
"""
_NumRepackTemp_

number of repacked streamer files (split in success/failure)

T0Mon: in the front page
"""

from T0.DAS.Database.Oracle.Stats.GeneralNumStat import GeneralNumStat

class NumRepackTemp(GeneralNumStat):
    fileset= 'Repack'
    sql = """SELECT streamer.run_id,
                    COUNT(wmbs_sub_files_complete.fileid) AS completed_count,
                    COUNT(wmbs_sub_files_failed.fileid) AS failed_count
             FROM streamer
             INNER JOIN wmbs_fileset_files ON
               wmbs_fileset_files.fileid = streamer.streamer_id
             LEFT OUTER JOIN wmbs_sub_files_complete ON
               wmbs_sub_files_complete.fileid = streamer.streamer_id AND
               wmbs_sub_files_complete.subscription = wmbs_fileset_files.fileset
             LEFT OUTER JOIN wmbs_sub_files_failed ON
               wmbs_sub_files_failed.fileid = streamer.streamer_id AND
               wmbs_sub_files_failed.subscription = wmbs_fileset_files.fileset
             WHERE wmbs_fileset_files.fileset = (SELECT id FROM wmbs_fileset WHERE name = :fileset)
             AND streamer.run_id >= :lowRunId
             AND streamer.run_id <= :highRunId
             GROUP BY streamer.run_id
             ORDER BY streamer.run_id
             """
    def buildQuery(self):
      self.bindVars.update({'fileset':self.fileset})