#!/usr/bin/env python
"""
_InsertTimeVsRate1Hour_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: InsertTimeVsRate1Hour.py,v 1.1 2010/03/17 15:22:47 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class InsertTimeVsRate1Hour(DBFormatter):
    
    sql = """SELECT stream.name AS name, min(insert_time) AS time, SUM(events)/93 AS event_rate,
               (SUM(filesize)/1048576)/93 AS data_rate, (SUM(filesize)/1024)/sum(events) AS event_size 
             FROM streamer 
             INNER JOIN stream ON streamer.stream_id = stream.id 
             WHERE streamer.insert_time > ((sysdate - to_date('01-JAN-1970','DD-MON-YYYY')) * (86400) - (3600*(1+2)))
             GROUP BY run_id, stream.name, lumi_id
             ORDER BY run_id, stream.name, lumi_id"""
             
    def execute(self, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)