#!/usr/bin/env python
"""
_StreamerTotals_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: StreamerTotals.py,v 1.1 2010/03/17 15:22:47 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class StreamerTotals(DBFormatter):
    
    sql = """SELECT SUM(events)as events, COUNT (streamer_id) as streamers, COUNT (DISTINCT lumi_id) as lumi_id
               FROM streamer
               WHERE run_id = :run"""
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)