#!/usr/bin/env python
"""
_StreamerToSplit_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: StreamersToSplit.py,v 1.4 2010/03/31 13:23:17 hufnagel Exp $"
__version__ = "$Revision: 1.4 $"

from WMCore.Database.DBFormatter import DBFormatter

class StreamersToSplit(DBFormatter):
    
    sql = """SELECT COUNT(*) as toSplit
             FROM streamer
             WHERE checkForZeroState(streamer.used) = 0
             AND run_id = :run"""

    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)
