#!/usr/bin/env python
"""
_ExpressLatency_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: ExpressLatency.py,v 1.1 2010/03/17 15:22:46 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class ExpressLatency(DBFormatter):
    
    #TODO: query needs to be fixed since completion_time doesn't exist
    
    sql = """SELECT lumi_id, MAX(wmbs_job.state_time - express_job_def.definition_time)AS LATENCY
             FROM express_job_def 
             INNER JOIN express_job_streamer_assoc USING(job_id)
             INNER JOIN repack_streamer_assoc USING(streamer_id)
             INNER JOIN wmbs_job_assoc
                 ON repack_streamer_assoc.repacked_id = wmbs_job_assoc.fileid
             INNER JOIN wmbs_job ON wmbs_job_assoc.job = wmbs_job.id
             INNER JOIN streamer USING (streamer_id)
             WHERE run_id = :run GROUP BY (lumi_id)"""
             
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)
