"""
_MergeJobTimes_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: MergeJobTimes.py,v 1.3 2010/04/07 13:11:51 hufnagel Exp $"
__version__ = "$Revision: 1.3 $"

from WMCore.Database.DBFormatter import DBFormatter

from T0 import Globals

class MergeJobTimes(DBFormatter):

    subscription = Globals.retrieveMergeSubscription()

    # no creation time and submission time: tracked by couch
    sql = """SELECT wmbs_job.state_time AS t1
             FROM wmbs_job
             INNER JOIN wmbs_jobgroup ON
               wmbs_jobgroup.id = wmbs_job.jobgroup AND
               wmbs_jobgroup.subscription = %d
             INNER JOIN wmbs_job_assoc ON
               wmbs_job_assoc.job = wmbs_job.id
             INNER JOIN wmbs_file_runlumi_map ON
               wmbs_file_runlumi_map.fileid = wmbs_job_assoc.fileid AND
               wmbs_file_runlumi_map.run = :run
             GROUP BY wmbs_job.id
             """ % subscription['id']


    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)
