"""
_RepackJobTimes_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: RepackJobTimes.py,v 1.1 2010/03/17 15:22:46 sryu Exp $"
__version__ = "$Revision: 1.1 $"

from WMCore.Database.DBFormatter import DBFormatter

class RepackJobTimes(DBFormatter):
    
    #TO: check what else is needed for return item
    sql = """SELECT J.definition_time t2, J.completion_time t1
              FROM repack_job_def J,
              INNER JOIN repack_job_streamer_assoc A 
                   ON A.job_id = J.job_id 
              INNER JOIN streamer S ON S.stremer_id = A.streamer_id
              LEFT OUTER JOIN job_status ST ON J.job_status = ST.id 
              WHERE S.run_id = :run
              """
                          
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given reco_status list and then format and return
        the result.
        """
        bindVars = {"run": run}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)
