class CheckedException(Exception):
    """
    _CheckedException_
    
    Wrap all the external service error in exprot system(PhEDEx and DBS). 
    This is kind of mimicking checked exception in java in concept wise.
    (This exception needs to be handled)  
    """
    
    def __init__(self, message):
        self.name = str(self.__class__.__name__)
        self.message = message
    
    def __str__(self):
        """create a string rep of this exception"""
        strg = "%s\n" % self.name
        strg += "Message: %s\n" % self.message
        return strg
    
class PhEDExServiceError(CheckedException):
    """
    _PhEDExServiceError_
    
    This exception needs to be handled. - normally just print out log message or
    send message to alert system 
    """

class DBSServiceError(CheckedException):
    """
    _DBSServiceError_
    
    This exception needs to be handled. - normally just print out log message or
    send message to alert system 
    """
    