#!/usr/bin/env python
"""
_HarvestingJob_

"""

__revision__ = "$Id: HarvestingJob.py,v 1.1 2010/04/06 22:38:52 hufnagel Exp $"
__version__ = "$Revision: 1.1 $"

from T0.JobFactory.FactoryInterface import FactoryInterface

class HarvestingJob(FactoryInterface):
    """
    _HarvestingJob_

    JobSpec Factory for building harvesting jobspecs

    """
    def __init__(self, workflowSpec):
        FactoryInterface.__init__(self, workflowSpec)
        self.run = self.workflow.workflowRunNumber()

    def __call__(self, jobName, fileLFNs, parentLFNs = None, maxEvents = -1, skipEvents = 0):
        """
        _operator()_

        Create a harvesting job spec

        """
        jobSpec = self.workflow.createJobSpec()
        jobSpec.parameters["RunNumber"] = self.run
        jobSpec.setJobType("Harvesting")
        jobSpec.setJobName(jobName)
        if self.workflow.parameters.has_key("OnlySites"):
            if self.workflow.parameters["OnlySites"] != None:
                if type(self.workflow.parameters["OnlySites"]) == str:
                    jobSpec.siteWhitelist.append(self.workflow.parameters["OnlySites"])
                else:
                    jobSpec.siteWhitelist.extend(self.workflow.parameters["OnlySites"])

        cfgInterface = jobSpec.payload.cfgInterface
        cfgInterface.inputFiles = fileLFNs
        return jobSpec
