#!/usr/bin/env python
"""
_ProcessingJob_

"""

__revision__ = "$Id: ProcessingJob.py,v 1.9 2010/04/06 22:39:42 hufnagel Exp $"
__version__ = "$Revision: 1.9 $"

from T0.JobFactory.FactoryInterface import FactoryInterface

class ProcessingJob(FactoryInterface):
    """
    _ProcessingJob_

    JobSpec Factory for building processing jobspecs

    """
    def __init__(self, workflowSpec):
        FactoryInterface.__init__(self, workflowSpec)
        self.run = self.workflow.workflowRunNumber()

    def __call__(self, jobName, fileLFNs, parentLFNs = None, maxEvents = -1, skipEvents = 0):
        """
        _operator()_

        Create a processing jobspec
        
        """
        jobSpec = self.workflow.createJobSpec()
        jobSpec.parameters["RunNumber"] = self.run
        jobSpec.parameters["MaxEvents"] = maxEvents
        jobSpec.parameters["SkipEvents"] = skipEvents
        jobSpec.setJobType("Processing")
        jobSpec.setJobName(jobName)
        if self.workflow.parameters.has_key("OnlySites"):
            if self.workflow.parameters["OnlySites"] != None:
                if type(self.workflow.parameters["OnlySites"]) == str:
                    jobSpec.siteWhitelist.append(self.workflow.parameters["OnlySites"])
                else:
                    jobSpec.siteWhitelist.extend(self.workflow.parameters["OnlySites"])

        if type(fileLFNs) != list:
            fileLFNs = [fileLFNs]

        cfgInterface = jobSpec.payload.cfgInterface
        cfgInterface.inputFiles = fileLFNs

        if parentLFNs != None:
            if type(parentLFNs) != list:
                parentLFNs = [parentLFNs]

            cfgInterface.addExtension("SecondaryInputFiles", parentLFNs)
            
        return jobSpec
