"""
_HTTPfetcher_

This class is used to fetch the json data from a DAS url.
The Json object is expected to be Dictionary typed
 
"""

from types import *
import json as json
import urllib2,threading
import time

MAX_CONNS=15     # Max symultaneus connections

class HTTPfetcher(object):
  data=[]
  sInfo=dict()
  reconnections=3  
  
	
  def __init__(self,url):
    self.url=url
    self.req = urllib2.Request(self.url) 
    ## set the header to accept json data
    self.req.add_header("Content-type","application/x-www-form-urlencoded")
    self.req.add_header("Accept","application/json")
    
  def execute(self):
    try: 
     self.response = urllib2.urlopen(self.req)
     self.jsonRaw = self.response.read()
     self.status=0
     jsonObj = json.loads(self.jsonRaw)
     
     #data MUST be a list of dictionaries
     if type(jsonObj) is ListType:
        self.data=jsonObj
        self.sInfo={}
     else: 
        self.data=[jsonObj,]

     #elif  type(jsonObj) is DictType:
       #if jsonObj.has_key('results'):
         #self.data= jsonObj['results']
         #self.sInfo =dict(self.jsonObj)
         #del self.sInfo['results']
        
       #elif jsonObj.has_key('Exception'):
         #self.data = [str(jsonObj['Exception']),str(jsonObj['Exception_type'])]
         #self.sInfo=jsonObj
     #else:
       #print "Unknown data type" 
       #self.data= jsonObj
      # hold exception on the data
    except Exception, e:
      self.status=1
      self.data=[str(e)]
      #try:
       #self.sInfo=jsonObj
      #except:
       #pass
    #fix  1-record long data to list type
    #if type(self.data) is not ListType:
       #self.data =[self.data, ]
    return self.status
	
  def getServiceInfo(self):
    return self.sInfo
  
  def fetchUrl(self):
     global  MAX_CONNS
     while MAX_CONNS<=0:
          time.sleep(3)
          #print "waiting..."
     MAX_CONNS=MAX_CONNS-1
     
     #print "Connecting to url="+self.url + "  conns="+str(MAX_CONNS)
     stat =self.execute()
     #I added this section because sometimes  queries fails to be fetched.
     while stat>0 and self.reconnections>0:
          time.sleep(3)
          print "Connection Error: retrying to connect"
          stat =self.execute()
          self.reconnections-=1
     if stat>0:
       MAX_CONNS=MAX_CONNS+1
       raise ConnectionException('ConnectionError','Connection error url='+self.url)
     #if self.url.startswith('http://vocms115.cern.ch:8301/tier0/numrepackcompleted') or self.url.startswith('http://vocms115.cern.ch:8301/tier0/numrepacktotal') or self.url.startswith('http://vocms115.cern.ch:8301/tier0/numrepackmerged') or self.url.startswith('http://vocms115.cern.ch:8301/tier0/numrepackmergedexported'):
       #print " URL="+self.url+ "======"+str(self.data)
     MAX_CONNS+=1 
     return self.data

################################################################################################    
      
class fetchingThread(threading.Thread):
    """
    This method is used from Statistic tables (and others) to fetch data in  separate threads 
    """
    def __init__ ( self, DASUrl, suffix, outDict):
      self.suffix=suffix
      self.outDict=outDict
      self.url= DASUrl+suffix
      threading.Thread.__init__(self)
    
    def run(self):
        try:
         f = HTTPfetcher(self.url)
         self.outDict.update({self.suffix:f.fetchUrl()})
        except ConnectionException:
            self.outDict.update({self.suffix:None})
 
       
      
###############################################################################################
class ConnectionException(Exception):
   """Exception raised for errors 
   """
   def __init__(self, name, msg=""):
        self.name = name
        self.msg = msg
 
   def __str__(self):
     return repr(self.msg)

        
   