"""
_MotT0History Page_

This page fetch an entire set of table and then organize/print it in a easy understandable way
 
""" 
from WMCore.WebTools.Page import TemplatedPage

from Table import *
import TableContents
from TableContents import content
from MotT0 import MotT0Page
import time


class historyContent(content):
    def  __init__(self,url):
        self.URL=url
        content.__init__(self)

class MotT0History(MotT0Page):
    title="MotT0 history page"
    streamerCode=""
    otherTablesCode=""
    vtypes={"StreamerFiles":'Strm',
     "RepackFiles":"Repkf","RepackJobs":"Repkj","RepackMergeJobs":"Repkmj","RepackMergeFiles":"Repkmf",
     "RecoFiles":"Recof","RecoJobs":"Recoj","RecoMergeJobs":"Recomj","RecoMergeFiles":"Recomf",
     "AlcaFiles":"Alcaf","AlcaJobs":"Alcaj","AlcaMergeJobs":"Alcamj","AlcaMergeFiles":"Alcamf",
     "ExpressFiles":"Exprf","ExpressJobs":"exprj","ExpressMergeJobs":"Exprmj","ExpressMergeFiles":"Exprmf",
     "DQMJobs":'DQMJ'}
    codes={}
    error=False
      
     
      
    def getContent(self,name):
     try:
       methodToCall = getattr(TableContents, 'H'+name)
       content=methodToCall(self.params)
       return content
     except Exception,e:
       print "Content not found for table: "+name + "  "+str(e)
       return None
      
    
    def addBlueBorder(self,code):
      return "<table style=\"border: 5px solid blue;\"><tr><td>"+ code+ "</td></tr></table>"
    
    def makeLayer(self,prefix,names,CSSclass=""):
      code="<table  border=\"0\" >  <tr > <td class=\""+CSSclass+"\" colspan=\"4\" > <b>"+prefix+ " Data<b/></td></tr>"
      try:
         code+="<tr>"
         for suffix in ["Jobs","Files","MergeJobs","MergeFiles"]:
           tableName=prefix+suffix 
           if tableName==self.firstTable: 
                 code+="<td class=\""+CSSclass+"\">"+self.addBlueBorder(self.codes[tableName])+"</td>"
           else: code+="<td class=\""+CSSclass+"\">"+self.codes[tableName]+"</td>"
         ###### special addition for DQM:
         if prefix=='Express':
           if 'DQMJobs'==self.firstTable: 
             code+="<td class=\""+CSSclass+"\">"+self.addBlueBorder(self.codes['DQMJobs'])+"</td>"
           else:
             code+="<td class=\""+CSSclass+"\">"+self.codes['DQMJobs']+"</td>"
         ############
         code+="</tr></table><br/>"
        
      except Exception, e:
        #print str(e)
        return ""
      return code
        
    def getTemplate(self):
      #generate code for tables
      try:
        self.firstTable=self.params['source']
        self.value=self.params['Id']
        try:
          r=int(self.value)
          t= self.vtypes[self.firstTable]
        except:
          self.error=True
          return self.errorPage("Wrong/Missing Parameter(s)")
        #print str(self.params)
        content=historyContent("allhistory?vtype="+self.vtypes[self.firstTable]+"&value="+self.value)
        dataTable= Table(self.DASUrl,content)
        data =dataTable.getData()
        
        code=""
        self.codes={}
        for tabledata in data:
          for raw in tabledata:
            if 'tablename' in raw:
               tableName=raw['tablename']
               tempData=[]
            else: tempData.append(raw)
          #print "Table :"+ tableName+ "   "+ str(tempData)
          tableContent=self.getContent(tableName)
          if tableContent!=None:
             #print "analysing "+str(tableContent)+ "  "+str(len(tempData))
             dataTable.content=tableContent
             dataTable.content.isLongTable=False
             self.codes[tableName]=dataTable.getTableCode(data=tempData)
        ##organize output
        try:
         self.streamerCode=self.codes['StreamerFiles']
         if self.firstTable=="StreamerFiles": self.streamerCode=self.addBlueBorder(self.streamerCode)
        except:
          self.streamerCode=" "
        self.otherTablesCode+=self.makeLayer("Express",self.vtypes.keys(),'expressBG')
        self.otherTablesCode+=self.makeLayer("Repack", self.vtypes.keys(),'repackBG')
        self.otherTablesCode+=self.makeLayer("Reco",   self.vtypes.keys(),'recoBG')
        self.otherTablesCode+=self.makeLayer("Alca",   self.vtypes.keys(),'alcaBG')
        
      except Exception as e:
        print str(e)
      if self.streamerCode=="":
        self.streamerCode="<B>Conncetion Error or wrong request</B>"
      if self.otherTablesCode=="":
        self.otherTablesCode="<B>Conncetion Error or wrong request</B>"
        
      #if self.error:
         #eParams={
            #"title": "Error",
            #"time" : time.ctime(),
            #"tmplPath": self.templatedir,
            #"msg": "Input Error. Please check URL"
              #}
         #return self.motT0Template.templatepage('error', **eParams )
      params={
            "page": "history",
            "title": self.title,
            #"time" : ctime(),
            "tmplPath": self.templatedir,
            "streamerTable": self.streamerCode,
            "otherTables":self.otherTablesCode
              }
      return self.motT0Template.templatepage('history', **params )
    
    