######################################################
#             Series objects are needed by plot ones
# 
#
#####################################################
import math

class serie(object):
    
    def __init__(self,name,interval=60):
        self.name=name
        self.INTERVAL=interval
        self.X=[]
        self.Y=[]
        
    def addInfo(self, line):
     pass
    
    
    def getXValues(self):
       return self.X
    
    def getYValues(self):
      return self.Y
###############################################################################      
      
class DatasetSerie(serie):
  # this kind of serie can generate:   (SCATTER PLOTS)
  # eventsPlot, eventSizesPlot, dataRatePlot  all within the same serie
   def __init__(self,name,interval):
       serie.__init__(self,name,interval)
       self.lastTime=None
       self.sum=0
       self.eventsSum=0
       self.filesizeSum=0
       self.eventSizesX=[]
       self.eventSizesY=[]
       self.dataRateX=[]
       self.dataRateY=[]
       self.eventsIntervalX=[]
       self.eventsIntervalY=[]
       self.allEventSizesY=[]
       
       
   
   def addInfo(self, line):
      if self.lastTime==None: 
          self.lastTime=line['time']
 
      self.X.append(line['time']) 
      self.Y.append(line['events'])
      try:
       self.allEventSizesY.append(int(line['filesize']/(line['events']*1024)))
      except: 
        self.allEventSizesY.append(0)
      
      if abs(line['time']-self.lastTime)>=self.INTERVAL:
           self.dataRateX.append(line['time'])
           value=float(self.sum*1000)/float(1024*self.INTERVAL*1024)
           #print "sum="+str(sum)+"==>>%f"%value
           if value>0.00000: 
               self.dataRateY.append(value/1000)
           else: self.dataRateX.pop()
           #######################
           self.eventsIntervalX.append(line['time'])
           value=self.eventsSum
           if value>0: 
               self.eventsIntervalY.append(float(value)/float(self.INTERVAL))
           else: self.eventsIntervalX.pop()
           #######################
           self.eventSizesX.append(line['time'])
           value=self.filesizeSum
           if value>0 and self.eventsSum>0: 
               self.eventSizesY.append(float(value)/float(self.eventsSum*1024))
           else: self.eventSizesX.pop()
           
           self.sum=0
           self.eventsSum=0
           self.filesizeSum=0
           self.lastTime=line['time']
           
      self.eventsSum+=int(line['events'])     
      self.sum+=int(line['filesize'])
      self.filesizeSum+=int(line['filesize'])
       
  
     
#####################################################################################3
class intervalSerie(serie):
  # this kind of serie can generate: (single dimension plots: BAR PLOTS)
  # 
   def __init__(self,name,minvalue,maxvalue,interval):
       serie.__init__(self,name,interval)
       self.minValue=self.getInterval(minvalue)
       self.maxValue=self.getInterval(maxvalue)
       self.Y={}
       self.offset={}
       self.outY=[]
       #print "INTERVAL="+str(self.INTERVAL)
       for i in range(self.minValue,self.maxValue+self.INTERVAL,self.INTERVAL):
          self.Y.update({i:0})
          self.offset.update({i:0})
       
       #
       
   def addInfo(self, line):
      start=max(self.minValue,self.getInterval(int(line['starttime'])))
      end=min(self.maxValue,self.INTERVAL+self.getInterval(int(line['endtime'])))
      try:
       #if (int(line['starttime'])-start)>self.INTERVAL: print "offset+=%d"%((int(line['starttime'])-start))
       #if (int(line['endtime'])-end)<-self.INTERVAL:  print "offset-=%d"%((int(line['endtime'])-end))
       s=int(line['starttime'])-start
       e=int(line['endtime'])-end #negative number
       self.offset[start]=self.offset[start]+s
       #if s>self.INTERVAL: print "SSSSSSSSSSSSSS="+str(s)
       #if e<-self.INTERVAL: print "EEEEEEEEEEEEEEEE="+str(e)
       #pr(int(line['endtime'])-end) #negative number
       self.offset[end]=self.offset[end]+e
       self.Y[start]=self.Y[start]+1
       self.Y[end]=self.Y[end]-1
      except Exception as e:
        print "Exception:"+str(e)
        #print "start="+str(start) +"  MIN="+str(self.minValue)+"   interval="+str(self.INTERVAL)
        #print "end="+str(end) +"  END="+str(self.maxValue)

      
   def getYValues(self):
      if len(self.outY)==0: self.generateOutList()
      return self.outY
  
   def generateOutList(self):
       ### the formula here calculated is:
       ## sum of all the runtime seconds = (alive jobs* interval length) + offset (new jobs) - offset (terminated jobs)
       ## ---------- (divided by)---------
       ## interval length
       ## ============================ 
       ## average # of job in the interval
       sumEndPrevious=0
       total=self.offset[self.minValue]
       for i in range(self.minValue,self.maxValue+self.INTERVAL,self.INTERVAL):
          total=sumEndPrevious+int(math.floor(self.offset[i]/self.INTERVAL))
          self.outY.append(total)
          sumEndPrevious+=self.Y[i]

          
          
   def getInterval(self,time):
     res= int(math.floor(time/self.INTERVAL)*self.INTERVAL)
     #print "map:"+str(time)+" in "+str(res) +"  " +str(opt)
     return res 
#############################################################################################3
