"""
__statistics__
"""

from Table import *
from HTTPfetcher import *
import threading
from TableContents import *


class StatThread(tableThread):
    def __init__ ( self, DASUrl, runid="" ):
      self.table=Statistics(DASUrl,runid)
      threading.Thread.__init__ ( self) 
########################################################################################################


class Statistics(Table):
  name='stats'
  tableTop="""<table border="0">
<tbody><tr><th colspan="2">%s </th></tr>"""
  tableRow="""<tr><td style="background-color: white;">%s</td><td style="background-color: white;"><a href="%s">%s</a></td></tr>"""
  tableFoot="""</tbody></table></div></td>""" 
  tablesData={}
  ########## links for the plots
  interlinks=["""<td class="stats" colspan="4"><table class="substat" width="100%" border="0"> 
      <tr><td class="stats"><div align="center"><a href="plots?tier=&hours=5">Streamer plots</a></div></td>
          <td class="stats"><div align="center"><a href="plots?tier=EXPRESS&hours=5">Express plots</a></div></td> 
          <td class="stats"><div align="center"><a href="plots?tier=RAW&hours=5">RAW Tier plots</a></div></td></tr></table></td></tr><tr> """,""" 
     <tr><td class="stats" colspan="2"><div align="center"><a href="plots?tier=RECO&hours=5">Reco Tier plots</a></div></td> 
          <td class="stats" colspan="2"><div align="center"><a href="plots?tier=ALCARECO&hours=5">AlcaReco Tier plots</a></div></td></tr>"""]
    
  def __init__(self,DASUrl,runid=""):
    self.runid=runid
    self.DASUrl=DASUrl
    self.tables=[expressTable(),expressMergeTable(),repackTable(),repackMergeTable(),recoTable(),recoMergeTable(),alcaTable(),alcaMergeTable(),DQMTable()]
    #]
    self.threads=[]
    for table in self.tables:
         t=  fetchingThread(DASUrl, table.URL%(str(self.runid)), self.tablesData)
         self.threads.append(t)
         t.start()
         

  def getTableCode(self):
      for t in self.threads:
          t.join()
      title="Statistics:"
      option=""
      if len(str(self.runid))>0:
          import Columns
          runCol= RunId()
          title="Statistics for run %s :"%(runCol.decorator({runCol.attrNames[0]:str(self.runid)}))
          option="?run_id="+str(self.runid)
          self.interlinks=["",""]   
      statCode="""<table  class="stats">
  <tr><td class="stats" colspan="4"> <div align="center">
  <a href="statplots?run_id=%s&autotime=1"> <img border="0" src="imgs/plot.png" alt="plots" title="statistical plots" width="20"> <b>%s</b></a></div>
  </td>
  </tr><tr>"""%(self.runid,title)
      
      for table in self.tables:
        #print table.title
        tableCode="""<td class="stats">
                     <div style="float:left;padding-right:10px;"> """   
        tableCode+=self.tableTop %(table.title)
        #print tdata
        tdata=self.tablesData[table.URL%(str(self.runid))]
        for status in table.tableStatuses:
         if tdata!=None:
          try:
           i=self.getIndexOfStatus(tdata,table.attrStatus,status)
           #if i==None: print " Impossible to find "+ status +"  in "+str(tdata)
           tableCode+=self.tableRow% (status,table.link%(str(self.runid),status),str(tdata[i][table.attrCount]))    
          except Exception, e:
           print "Exception: "+str(e)
        tableCode+=self.tableFoot
        statCode+=tableCode
        if self.tables.index(table)%4==3: # and self.tables.index(table)+1<len(self.tables) : 
           statCode+="""</tr><tr>"""
           statCode+=self.interlinks[self.tables.index(table)/4] 
      #statCode+=self.bottomlinks 
      statCode+="""</tr><tr><td class="stats" colspan="4"><div id="statslink" align="right"><a href="javascript:loadXMLDoc('stats','stats%s')" title="Refresh"> <img src="imgs/reload.png"  alt="" style="border: 0px none;" height="16"></a></div></td></tr></table>"""%(option)
      return statCode
        
  def getIndexOfStatus(self,listOfDict,key,value):
       i=0
       while i<len(listOfDict):
        if str(listOfDict[i][key]).lower()==value.lower(): 
            return i
        i=i+1
       return None  