import os,time,re,cherrypy,smtplib,socket
 
 
REFRESH_FLAG_FILE="Mott0Refreshing"
TMP_FILE="Mott0-tmp"
ALARM_FLAG="Mott0-alarm-%s"
CACHE_FILE="Mott0CachedIndex.html"
REFRESH_TIMEOUT=1500
ALARM_INTERVAL=3600
TMP_DIR="var/"


MAIL_MESSAGE="""From: Mott0<MotT0-service@cern.ch>
To: %s <%s>
Subject: MotT0 error

MotT0 URL= %s
DAS   URL= %s

%s
""" 

CONFIG_ERROR_MSG="""<B>Error:</B> Service not correctly initialized. Impossible to continue. :( """
DAS_ERROR_MSG="""<B>Error:</B> Impossible to connect to DAS. Page generations aborted.  :( <BR />  Support has been informed. """

def sendAlarm(receiver,DASUrl,errorMessage=""):
  MotT0Port=cherrypy.config['server.socket_port']
  # the alarm may be sent to different addresses: I need a flag for any of them
  ALARM_FILE=ALARM_FLAG%(str(receiver))
  if (existsFile(ALARM_FILE)):
    if fileOlderThan(ALARM_FILE, ALARM_INTERVAL):
      removeFile(ALARM_FILE) 
  if not(existsFile(ALARM_FILE)):
    sender = 'MotT0-service@cern.ch'
    #receiver=self.config.emailAlert
    print "Sending mail to: "+str(receiver)
    message = MAIL_MESSAGE
    message=message%(receiver,receiver,"http://"+socket.gethostname()+":"+str(MotT0Port)+"/",DASUrl,errorMessage)
    try:
      smtpObj = smtplib.SMTP('localhost')
      smtpObj.sendmail(sender, receiver, message)  
      print "Successfully sent email"
      setFlag(ALARM_FILE)
    except Exception:
      print "Error: unable to send email"
#######################################################################
def  workingDAS(DASUrl):
  try:
    from HTTPfetcher import HTTPfetcher
    f=HTTPfetcher(DASUrl+"lastruns")
    data=f.fetchUrl()
    return True
  except:
    return False
##################################################################### Configuration options check
def configurationCheck(MotT0Template):
  #if (existsFile(CACHE_FILE)): return True
  ## any error is fatal to the service execution
  
  ## checking templates dir
  log=""
  DAS=""
  try:
    template=MotT0Template.templatedir
  except  AttributeError, e:
    log+="Error: Template PATH missing \n"
  ## cehcking DAS url
  try:
    DAS=MotT0Template.config.DAS
  except  AttributeError, e:
    log+="Error: DAS URL missing \n"
  ## checking mail address
  try:
    email=MotT0Template.config.emailAlert
    if re.match("^[a-zA-Z0-9._%-]+@cern.ch", email)==None:
      raise AttributeError
  except  AttributeError, e:
    log+="Error: mail alert missing or not accepted \n"
  ## checking plotfairy url
  try:
    st=MotT0Template.config.plotfairy
  except  AttributeError, e:
    log+="Error: PlotFairy url missing \n"
  if len(log)>0:
    return False,log
  return True,log
##################################################### filesystem opeartions


            
def fileOlderThan(file, time):
  try:
    statinfo = os.stat(TMP_DIR+file)
    ftime=  statinfo.st_mtime
    with open(TMP_DIR+TMP_FILE, 'w') as f:
      f.write("1")
    f.close()
    statinfo = os.stat(TMP_DIR+TMP_FILE)
    os.remove(TMP_DIR+TMP_FILE)
    #print "difference file timestamps: %f  timeout=%f on %s"%(statinfo.st_mtime-ftime,time,str(file))
    if statinfo.st_mtime-ftime>=time:
       print "file: "+str(TMP_DIR+file)+ " older then "+str(time)
       return True
  except: 
     return False
  return False
          
def getCachedFile(file=CACHE_FILE):
  # ONLY files in var/ are accessable (if file has a path component I drop it)
  (head,tail)=os.path.split(file)
  if not os.path.exists(TMP_DIR+tail):
      #print "*********************file not found: "+str(file)
      return "Wrong file or resource not availabe!"
  with open(TMP_DIR+tail, 'r') as f:
         read_data = f.read()
  if file.endswith('.png'): 
     # I don't know why I have to do t this way, but it is the only way to make it work
     cherrypy.response.headers['Content-Type']= "image/png"
     cherrypy.response.body=read_data
     return  cherrypy.response.body
  return read_data 
    
def existsFile(file):
   # ONLY files in var/ are accessable (if file has a path component I drop it)
  (head,tail)=os.path.split(file)
  return os.path.exists(TMP_DIR+tail)
    
def saveDataInFile(data,file):
  # ONLY files in var/ are accessable (if file has a path component I drop it)
  (head,tail)=os.path.split(file)
  with open(TMP_DIR+tail, 'w') as f:
        f.write(data)

def setFlag(file):
  (head,tail)=os.path.split(file)
  with open(TMP_DIR+tail, 'w') as f:
    f.write("1")
        
                   
def removeFile(file):
   # ONLY files in var/ are accessable (if file has a path component I drop it)
   (head,tail)=os.path.split(file)
   if not os.path.exists(TMP_DIR+tail):
      return "Wrong file"
   print "Removing file: " +str(TMP_DIR+file)
   try:
      os.remove(TMP_DIR+file)
   except:
      print "File not found"
      
      
def removeTempFiles(function):
   for file  in os.listdir(TMP_DIR):
       if function(file):
           removeFile(file)
