#!/usr/bin/env python
"""
_AllIn_

Simple Algorithm that generates a single job from a list of trigger segments
and includes all segments into that job.

Used for processing closeout, and very lazy scheduling algorithms

"""
from T0.RepackerScheduler.AlgorithmInterface import AlgorithmInterface
from T0.RepackerScheduler.Registry import registerAlgorithm


class AllIn(AlgorithmInterface):
    """
    _AllIn_

    Generate single job definition containing all the trigger segments
    fed into the call()

    
    """
    
    def __call__(self, *segments, **args):
        """
        _operator()_

        All segments go into one job definition
        
        """
        if len(segments) == 0:
            #return empty list of jobs
            return []
        result = self.newJobEntity(*segments)
        return [result]


registerAlgorithm(AllIn.__name__, AllIn)

