"""
API interface specific to RepackerScheduler
"""

__revision__ = "$Id: RepackerSchedulerAPI.py,v 1.23 2009/12/05 17:43:01 hufnagel Exp $"
__version__ = "$Revision: 1.23 $"


import logging

from T0.State.Database.Writer.InsertJob import insertJobDef
from T0.State.Database.Writer.InsertJob import assocRepackJobToStreamer
from T0.State.Database.Writer.InsertTriggerSegment import updateTriggerSegmentStatus


def registerJobs(dbConn, jobEntityList):
    """
    _registerJobs_
    
    Call registerJob for each job in the list

    """
    for jobEntity in jobEntityList:
        registerJob(dbConn, jobEntity)


def registerJob(dbConn, jobEntity):
    
    """
    _registerJob_

    Create a new job definition & get ID from database
    Insert job id/dataset/streamer association

    """

    jobID = insertJobDef(dbConn, "Repack", "New")

    assocRepackJobToStreamer(dbConn, jobID,
                             jobEntity['streamerIDs'])

    updateTriggerSegmentStatus(dbConn,
                               jobEntity["streamerIDs"],
                               jobEntity["datasetIDs"],
                               "Used")

