#!/usr/bin/env python
"""
_ListLumisections_
Read operation related block and active_block table in T0AST 
"""

def countLumisByRun(dbConn, runNumber):
    """
    _countLumisByRun_
    count number of lumis by given run
    """
    lumiQuery = "SELECT count(lumi_id) FROM lumi_section WHERE run_id = :runNumber"

    bindVars = {"runNumber": runNumber}
    dbConn.execute(lumiQuery, bindVars)
    result = dbConn.fetchall()
    
    return result[0][0]
