#!/usr/bin/env python
"""
_InsertJob_

Utils for inserting rows into the job_instance and job_def tables as well
as updating the information in them.
"""

__revision__ = "$Id: InsertJob.py,v 1.35 2011/01/06 13:58:30 hufnagel Exp $"
__version__ = "$Revision: 1.35 $"

import time
import logging


def updateWMBSJobNames(dbConn, jobNameDict):
    """
    _updateJobName_

    take the passed dict and updates every
    wmbs_job with id = key to name = value

    """
    sqlQuery = """UPDATE wmbs_job
                  SET name = :name
                  WHERE id = :id
                  """

    bindVarList = []
    for id, name in jobNameDict.items():
        bindVarList.append( { 'id' : id,
                              'name' : name } )

    dbConn.execute(sqlQuery, bindVarList)
    return


def updateWMBSJobOutcome(dbConn, id):
    """
    _updateWMBSJobOutcome_

    updates WMBS job outcome to 1
    (aka job was successful)

    """
    sqlQuery = """UPDATE wmbs_job
                  SET outcome = 1
                  WHERE id = :ID
                  """

    bindVars = { 'ID' : id }
    dbConn.execute(sqlQuery, bindVars)
    return
