######################################################
#             Series objects are needed by plot ones
# 
#  TO DO: 
#####################################################
import math

class series(object):
  """
   this object formats informations contained in dictionaries (tuples from the DB) into list of values (ready to be sent to plotfairy) 
  """
  def __init__(self,name,interval=60):
    """
     the init method set the name and a interval in seconds
    """
    self.name=name
    self.interval=interval
    self.X=[]
    self.Y=[]
       
  def addInfo(self, line):
   """
    addInfo method is used to process (and add to the serie) a given dictionary
   """
   pass
    
  def getXValues(self):
    return self.X
  
  def getYValues(self):
    return self.Y
###############################################################################      
      
class DatasetSeries(series):
  """ 
   this kind of serie can generate:   (SCATTER PLOTS)
   eventsPlot, eventSizesPlot, dataRatePlot  all within the same serie
  """
  def __init__(self,name,interval):
    series.__init__(self,name,interval)
    self.lastTime=None
    self.sum=0
    self.eventsSum=0
    self.filesizeSum=0
    # I add to those list the corresponding information in the addInfo method
    #plot can then fetch the value they desire
    self.eventSizesX=[]
    self.eventSizesY=[]
    # data rate is sum(filesize)/ # of seconds
    self.dataRateX=[]
    self.dataRateY=[]
    # events per interval is sum(events)/ # of seconds
    self.eventsIntervalX=[]
    self.eventsIntervalY=[]
    self.allEventSizesY=[]
       
  def __str__(self):
     """
     useful for debugging process
     """ 
     return "sizes="+str(len(self.X))+"  "+str(len(self.Y))
   
  def addInfo(self, line):
    # I use lastTime as reference for the last entry time value 
    if self.lastTime==None: 
      self.lastTime=line['time']
    self.X.append(line['time']) 
    self.Y.append(line['events'])
    try:
      self.allEventSizesY.append(int(line['filesize']/(line['events']*1024)))
    except: 
      self.allEventSizesY.append(0)
      
    if abs(line['time']-self.lastTime)>=self.interval:
      self.dataRateX.append(line['time'])
      # to save the value from approximation truncating I need to multiply it by 1000
      value=float(self.sum*1000)/float(1024*self.interval*1024)
      #print "sum="+str(sum)+"==>>%f"%value
      if value>0.00000: 
         self.dataRateY.append(value/1000)
      #if the value of Y is 0 I dorp the X value
      else: self.dataRateX.pop()
       #######################
      self.eventsIntervalX.append(line['time'])
      value=self.eventsSum
      if value>0: 
         self.eventsIntervalY.append(float(value)/float(self.interval))
      else: self.eventsIntervalX.pop()
       #######################
      self.eventSizesX.append(line['time'])
      value=self.filesizeSum
      if value>0 and self.eventsSum>0: 
        self.eventSizesY.append(float(value)/float(self.eventsSum*1024))
      else: self.eventSizesX.pop()
           
      self.sum=0
      self.eventsSum=0
      self.filesizeSum=0
      self.lastTime=line['time']
    #if we are still inside the interval I simply add the value to the sum* variables
    self.eventsSum+=int(line['events'])     
    self.sum+=int(line['filesize'])
    self.filesizeSum+=int(line['filesize'])
  
     
#####################################################################################3
class intervalSeries(series):
  """
  this kind of series can generate: (single dimension plots: BAR PLOTS)
  this series need to remember the interval of time every process spent living.
  To do so I create a vector with timestamp index and  I add +1 to the vector[start-timestamp] and -1 to vector[end-timestamp]
  a final post processing phase is needed to have the actual quantities  
  """
  def __init__(self,name,minvalue,maxvalue,interval):
    series.__init__(self,name,interval)
    self.minValue=self.getInterval(minvalue)
    self.maxValue=self.getInterval(maxvalue)
    self.Y={}
    self.offset={}
    self.outY=[]
    for i in range(self.minValue,self.maxValue+self.interval,self.interval):
      self.Y.update({i:0})
      self.offset.update({i:0})
       
  
  def addInfo(self, line):
    start=max(self.minValue,self.getInterval(int(line['starttime'])))
    end=min(self.maxValue,self.interval+self.getInterval(int(line['endtime'])))
    try:
      s=int(line['starttime'])-start
      e=int(line['endtime'])-end #negative number
      self.offset[start]=self.offset[start]+s
      self.offset[end]=self.offset[end]+e
      self.Y[start]=self.Y[start]+1
      self.Y[end]=self.Y[end]-1
    except Exception as e:
        print "Exception:"+str(e)

      
  def getYValues(self):
    if len(self.outY)==0: self.generateOutList()
    return self.outY
  
  def generateOutList(self):
    ### Post processing:
    ### the formula here calculated is:
    ## sum of all the runtime seconds = (alive jobs* interval length) + offset (new jobs) - offset (terminated jobs)
    ## ---------- (divided by)---------
    ## interval length
    ## ============================ 
    ## average # of job in the interval
    sumEndPrevious=0
    total=self.offset[self.minValue]
    for i in range(self.minValue,self.maxValue+self.interval,self.interval):
      total=sumEndPrevious+int(math.floor(self.offset[i]/self.interval))
      self.outY.append(total)
      sumEndPrevious+=self.Y[i]

  def getInterval(self,time):
    res= int(math.floor(time/self.interval)*self.interval)
    return res 
#############################################################################################3
