#!/usr/bin/env python
"""
_AlcaSkim_

Job handler for AlcaSkim jobs.
"""

__revision__ = "$Id: AlcaSkim.py,v 1.14 2011/01/19 21:23:47 hufnagel Exp $"
__version__ = "$Revision: 1.14 $"

import logging

from T0 import Globals

from T0.Tier0Accountant.WMBSBaseHandler import WMBSBaseHandler
from T0.State.Database.Writer import InsertRunConfig

class AlcaSkim(WMBSBaseHandler):
    """
    _AlcaSkim_

    Job handler for AlcaSkim jobs.

    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_

        call base handler
        update pset hash if that suceeds

        """
        logging.debug("AlcaSkimHandler handles successful job id: %s"
                      % jobInfo["JOB_IDENTIFIER"])
        
        wmbsJobInfo = WMBSBaseHandler.handleSuccessfulJob(self, jobInfo, jobFiles)

        if wmbsJobInfo != None:

            # update the PSetHash
            if len(jobFiles) > 0:

                t0astFile = jobFiles[0]
                InsertRunConfig.updatePSetHash(self.t0astDBConn,
                                               "alca_config",
                                               t0astFile["RUN_ID"],
                                               t0astFile["DATASET_ID"],
                                               t0astFile["PSET_HASH"])

        return wmbsJobInfo


    def getFilesetListByFile(self, wmbsFile):
        """
        _getFilesetListByFile_ 
        
        retrieve the fileset list for next processing steps

        """
               
        filesetList = []   

        filesetList.append( Globals.retrieveMergeSubscription()['fileset'].id )
        
        return filesetList

