#!/usr/bin/env python
"""
_Express_

Job handler for Express jobs.
"""

__revision__ = "$Id: Express.py,v 1.17 2011/01/19 21:23:47 hufnagel Exp $"
__version__ = "$Revision: 1.17 $"

import logging

from T0 import Globals

from T0.Tier0Accountant.WMBSBaseHandler import WMBSBaseHandler


class Express(WMBSBaseHandler):
    """
    _Express_

    Job handler for Express jobs.

    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_

        call base handler

        """
        logging.debug("ExpressHandler handles successful job id: %s"
                      % jobInfo["JOB_IDENTIFIER"])

        return WMBSBaseHandler.handleSuccessfulJob(self, jobInfo, jobFiles)


    def getFilesetListByFile(self, t0astFile):
        """
        _getFilesetListByFile_ 
        
        retrieve the fileset list for next processing steps

        """
        filesetList = []

        filesetList.append( Globals.retrieveExpressMergeSubscription()['fileset'].id )

        return filesetList
