#!/usr/bin/env python
"""
_ExpressDQMHarvest_

Job handler for ExpressDQMHarvest jobs.
"""

__revision__ = "$Id: ExpressDQMHarvest.py,v 1.4 2011/01/19 21:23:47 hufnagel Exp $"
__version__ = "$Revision: 1.4 $"

import logging

from T0.Tier0Accountant.WMBSBaseHandler import WMBSBaseHandler

class ExpressDQMHarvest(WMBSBaseHandler):
    """
    _ExpressDQMHarvest_

    Job handler for DQMHarvest jobs (and ALCAPROMPTHarvest jobs)

    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_
        
        sanity check for job having no output
        call base handler

        """
        logging.debug("ExpressDQMHarvestHandler handles successful job id: %s"
                      % jobInfo["JOB_IDENTIFIER"])     

        if len(jobFiles) != 0:
            logging.error("WARNING: Harvest jobs should not have any output: %s" % jobFiles)

        return WMBSBaseHandler.handleSuccessfulJob(self, jobInfo, jobFiles)
