#!/usr/bin/env python
"""
_MCStreamer_

Job handler for MCStreamer jobs.
"""

__revision__ = "$Id: MCStreamer.py,v 1.3 2010/09/03 21:48:09 hufnagel Exp $"
__version__ = "$Revision: 1.3 $"

import logging

from T0.Tier0Accountant.JobHandlerInterface import JobHandlerInterface
from T0.State.Database.Writer import InsertStreamer

class MCStreamer(JobHandlerInterface):
    """
    _MCStreamer_
    
    Job handler for T0 MC Feed for streamer

    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_
        
        jobFiles param contains list of StreamerFile structure 

        """
        logging.debug("MCStreamerHandler handles successful job id: %s"
                      % jobInfo["JOB_IDENTIFIER"])

        InsertStreamer.insertStreamers(self.t0astDBConn, jobFiles)

    def handleFailedJob(self, jobInfo):
        """
        _handleFailedJob_
        
        currently not doing anything on failed job

        """
        pass
