#!/usr/bin/env python
"""
_MergePack_

Job handler for MergePack jobs.
"""

__revision__ = "$Id: MergePack.py,v 1.20 2011/01/19 21:23:47 hufnagel Exp $"
__version__ = "$Revision: 1.20 $"

import logging

from T0 import Globals

from T0.Tier0Accountant.WMBSBaseHandler import WMBSBaseHandler

class MergePack(WMBSBaseHandler):
    """
    _MergePack_

    Job handler for MergePack jobs.

    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_

        call base handler

        """
        logging.debug("MergePackHandler handles successful job id:%s"
                      % jobInfo["JOB_IDENTIFIER"])

        # update merge flag
        for jobFile in jobFiles:
            jobFile["MERGED"] = True

        return WMBSBaseHandler.handleSuccessfulJob(self, jobInfo, jobFiles)


    def getFilesetListByFile(self, t0astFile):
        """
        _getFilesetListByFile_ 
        
        retrieve the fileset list for next processing steps

        """
        filesetList = []

        if t0astFile["DATA_TIER"] == "DQM":
            filesetList.append( Globals.retrieveDQMSubscription()['fileset'].id )
        elif t0astFile["DATA_TIER"] == "ALCARECO":
            filesetList.append( Globals.retrieveExpressDBSSubscription()['fileset'].id )
        elif t0astFile["DATA_TIER"] == "ALCAPROMPT":
            filesetList.append( Globals.retrieveExpressDBSSubscription()['fileset'].id )
            filesetList.append( Globals.retrieveAlcaHarvestSubscription()['fileset'].id )
        else:
            filesetList.append( Globals.retrieveExpressDBSSubscription()['fileset'].id )

        return filesetList
