#!/usr/bin/env python
"""
_Repack_

Job handler for Repack jobs.
"""

__revision__ = "$Id: Repack.py,v 1.23 2011/01/19 21:23:47 hufnagel Exp $"
__version__ = "$Revision: 1.23 $"

import logging

from T0 import Globals

from T0.Tier0Accountant.WMBSBaseHandler import WMBSBaseHandler


class Repack(WMBSBaseHandler):
    """
    _Repack_

    Job handler for Repack jobs.

    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_

        call base handler

        """
        logging.debug("RepackHandler handles successful job id: %s"
                      % jobInfo["JOB_IDENTIFIER"])

        return WMBSBaseHandler.handleSuccessfulJob(self, jobInfo, jobFiles)


    def getFilesetListByFile(self, t0astFile):
        """
        _getFilesetListByFile_ 
        
        retrieve the fileset list for next processing steps

        only depends on whether stageout to merged was triggered or not
        
        """
        filesetList = []

        if t0astFile["MERGED"]:
            filesetList.append( Globals.retrieveDBSUploadSubscription()['fileset'].id )
            filesetList.append( Globals.retrieveRecoSubscription()['fileset'].id )
        else:
            filesetList.append( Globals.retrieveMergeSubscription()['fileset'].id )

        return filesetList
